//**************************************************************************//
//  Project     | AnobPʐMR|[lguAlohaPC1CommXv         //
//              | CXg[iACXg[܂ށj                      //
//--------------------------------------------------------------------------//
//  Unit        | CtH[                                            //
//--------------------------------------------------------------------------//
//  File Name   | Main.pas                                                  //
//  Platform    | Windows 2000                                              //
//  Compiler    | Delphi5,6                                                 //
//  Last Update | 2002/12/25                                                //
//--------------------------------------------------------------------------//
//  Copyright (c) 2002 Hitwareland Corporation.                             //
//  All rights reserved.                                                    //
//  programmed by Hitoshi Komatsu                                           //
//--------------------------------------------------------------------------//
//                      <<< Updated History >>>                             //
//--------------------------------------------------------------------------//
//  2002/10/12 | 쐬Jn                                                   //
//       12/25 | Delphi5 ւ̑Ή                                           //
//**************************************************************************//
unit Main;

interface

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
//                                                                          //
//   gpjbg錾                                                     //
//                                                                          //
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
uses
  { Delphi }
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Buttons, StdCtrls, ComCtrls, ComObj, ActiveX, Registry;

const
  DLL_FILENAME = 'ndaaloha.dll'; // ckkt@C

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
//                                                                          //
//   CtH[NX                                                 //
//                                                                          //
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
type
  TMainForm = class(TForm)
    Image1: TImage;
    Panel1: TPanel;
    Notebook1: TNotebook;
    Label1: TLabel;
    StateMemo: TMemo;
    InstallButton: TBitBtn;
    UninstallButton: TBitBtn;
    ExitButton: TBitBtn;
    InstMemo: TMemo;
    InstTitleLabel: TLabel;
    InstCloseButton: TButton;
    InstBackButton: TButton;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure InstCloseButtonClick(Sender: TObject);
    procedure InstBackButtonClick(Sender: TObject);
    procedure InstallButtonClick(Sender: TObject);
    procedure UninstallButtonClick(Sender: TObject);
    procedure ExitButtonClick(Sender: TObject);
  private
    { Private 錾 }
    FInstallDir: string;
    procedure ShowMenuPage;
    procedure StartInstall;
    procedure StartUninstall;
  public
    { Public 錾 }
  end;

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
//                                                                          //
//   O[oIuWFNg                                               //
//                                                                          //
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
var
  MainForm: TMainForm;                  // CtH[IuWFNg


implementation

{$R *.dfm}

//**************************************************************************//
//  Name      | GetInstalledDllPath                                         //
//  Comment   | CXg[pX𒲂ׂ                                  //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  DllPath         | O | ndaaloha.dll ̃CXg[tpX           //
//--------------------------------------------------------------------------//
//  Result    | True  = WXgɓo^Ă                          //
//            | False = WXgɓo^ĂȂ                        //
//**************************************************************************//
function GetInstalledDllPath(var DllPath: string): Boolean;
var
  ClassID: TGUID;
  ClassIDStr: string;
  Key: string;
  Reg: TRegistry;
begin
  Result := False;
  try
    ClassID := ProgIDToClassID('NDAALohaPC1.AlohaPC1CommX');
    ClassIDStr := GUIDToString(ClassID);

    Reg := TRegistry.Create;
    try
      Reg.RootKey := HKEY_CLASSES_ROOT;
      Key := 'CLSID\' + ClassIDStr + '\InprocServer32';
      if Reg.OpenKeyReadOnly(Key) then begin
        DllPath := Reg.ReadString('');
        Result := True;
      end;
    finally
      Reg.Free;
    end;
  except
    Result := False;
  end;
end;

//**************************************************************************//
//  Name      | InstallRegistry                                             //
//  Comment   | ndaaloha.dll WXgɓo^                         //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  DllPath         | I | ndaaloha.dll ̃tpX                         //
//  ErrMsg          | O | G[̃G[bZ[WiResult=FalseLj  //
//--------------------------------------------------------------------------//
//  Result    | True  = WXgɓo^ł                              //
//            | False = WXgɓo^łȂ                        //
//**************************************************************************//
function InstallRegistry(const DllPath: string; var ErrMsg: string): Boolean;
type
  TDllRegisterServerProc = function: Integer; stdcall;
var
  hDll: HMODULE;
  DllRegisterServer: TDllRegisterServerProc;
begin
  Result := False;

  // ndaaloha.dll [h
  hDll := LoadLibrary(PChar(DllPath));
  if hDll < 32 then begin
    ErrMsg := DllPath + ' [hł܂B';
    Exit;
  end;

  try
    // DllRegisterServer ֐AhX̎擾
    @DllRegisterServer := GetProcAddress(hDll, 'DllRegisterServer');
    if @DllRegisterServer = nil then begin
      ErrMsg := DllPath + '  DllRegisterServer ֐܂B';
      Exit;
    end;

    // DllRegisterServer ֐s
    if FAILED(DllRegisterServer) then begin
      ErrMsg := DllPath + '  DllRegisterServer ֐ĂяoŃG[Ԃ܂B';
      Exit;
    end;

    // WXgo^I
    Result := True;
  finally
    FreeLibrary(hDll);
  end;
end;

//**************************************************************************//
//  Name      | UninstallRegistry                                           //
//  Comment   | ndaaloha.dll WXg                       //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  DllPath         | I | ndaaloha.dll ̃tpX                         //
//  ErrMsg          | O | G[̃G[bZ[WiResult=FalseLj  //
//--------------------------------------------------------------------------//
//  Result    | True  = WXgł                            //
//            | False = WXgłȂ                      //
//**************************************************************************//
function UninstallRegistry(const DllPath: string; var ErrMsg: string): Boolean;
type
  TDllUnregisterServerProc = function: Integer; stdcall;
var
  hDll: HMODULE;
  DllUnregisterServer: TDllUnregisterServerProc;
begin
  Result := False;

  // ndaaloha.dll [h
  hDll := LoadLibrary(PChar(DllPath));
  if hDll < 32 then begin
    ErrMsg := DllPath + ' [hł܂B';
    Exit;
  end;

  try
    // DllUnregisterServer ֐AhX̎擾
    @DllUnregisterServer := GetProcAddress(hDll, 'DllUnregisterServer');
    if @DllUnregisterServer = nil then begin
      ErrMsg := DllPath + '  DllUnregisterServer ֐܂B';
      Exit;
    end;

    // DllUnregisterServer ֐s
    if FAILED(DllUnregisterServer) then begin
      ErrMsg := DllPath + '  DllUnregisterServer ֐ĂяoŃG[Ԃ܂B';
      Exit;
    end;

    // WXgo^I
    Result := True;
  finally
    FreeLibrary(hDll);
  end;
end;

//**************************************************************************//
//  Name      | TMainForm.FormCreate                                        //
//  Comment   | tH[                                              //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Sender          | I | MainForm                                          //
//**************************************************************************//
procedure TMainForm.FormCreate(Sender: TObject);
var
  Len: Integer;
begin
  // CXg[VXefBNgɐݒ肷
  SetLength(FInstallDir, 255);
  Len := GetSystemDirectory(PChar(FInstallDir), 255);
  SetLength(FInstallDir, Len);

  // j[y[W\
  ShowMenuPage;
end;

//**************************************************************************//
//  Name      | TMainForm.ShowMenuPage                                      //
//  Comment   | ʂ̕\                                              //
//**************************************************************************//
procedure TMainForm.ShowMenuPage;
var
  InstalledDir, DllName, DllPath: string;
begin
  Notebook1.PageIndex := 0;
  StateMemo.Lines.Clear;

  // CXg[ĂfBNg𒲂ׂ
  if GetInstalledDllPath(DllPath) then begin
    InstalledDir := ExtractFileDir(DllPath);
    DllName := ExtractFileName(DllPath);
    if FileExists(DllPath) then
      StateMemo.Lines.Add( Format('%s  %s CXg[Ă܂B', [InstalledDir, DllName]) )
    else begin
      StateMemo.Lines.Add( Format('%s ɃCXg[Ă܂A%s 폜Ă܂B', [InstalledDir, DllName]) );
      StateMemo.Lines.Add('ăCXg[KvłB');
    end;
  end
  else
    StateMemo.Lines.Add('܂CXg[Ă܂B');
end;

//**************************************************************************//
//  Name      | TMainForm.StartInstall                                      //
//  Comment   | CXg[                                            //
//**************************************************************************//
procedure TMainForm.StartInstall;
var
  CurrentDir, DllSrcPath: string;
  DllDestPath: string;
  Len: Integer;
  ErrMsg: string;
begin
  Notebook1.PageIndex := 1;
  InstTitleLabel.Caption := 'CXg[󋵁';
  InstMemo.Lines.Clear;
  InstMemo.Lines.Add('CXg[Ă܂...');

  // JgfBNg ndaaloha.dll 邩ǂׂ
  SetLength(CurrentDir, 255);
  Len := GetCurrentDirectory(255, PChar(CurrentDir));
  SetLength(CurrentDir, Len);
  if CurrentDir[Length(CurrentDir)] = '\' then
    DllSrcPath := CurrentDir + DLL_FILENAME
  else
    DllSrcPath := CurrentDir + '\' + DLL_FILENAME;
  if not FileExists(DllSrcPath) then begin
    InstMemo.Lines.Add( Format('%s  %s Ȃ߃CXg[ł܂B', [CurrentDir, DLL_FILENAME]) );
    Exit;
  end;

  // VXefBNgɃRs[
  if FInstallDir[Length(FInstallDir)] = '\' then
    DllDestPath := FInstallDir + DLL_FILENAME
  else
    DllDestPath := FInstallDir + '\' + DLL_FILENAME;
  if not CopyFile(PChar(DllSrcPath), PChar(DllDestPath), False) then begin
    InstMemo.Lines.Add( Format('%s  %s ɃRs[ł܂B', [DllSrcPath, FInstallDir]) );
    Exit;
  end;

  InstMemo.Lines.Add( Format('%s  %s ɃRs[܂B', [DLL_FILENAME, FInstallDir]) );

  // ndaaloha.dll WXgɓo^
  if not InstallRegistry(DllDestPath, ErrMsg) then begin
    InstMemo.Lines.Add( ErrMsg );
    Exit;
  end;

  InstMemo.Lines.Add( Format('%s WXgɓo^܂B', [DllDestPath]) );

  // ɃCXg[
  InstMemo.Lines.Add('ɃCXg[ł܂B');
end;

//**************************************************************************//
//  Name      | TMainForm.StartUninstall                                    //
//  Comment   | ACXg[                                        //
//**************************************************************************//
procedure TMainForm.StartUninstall;
var
  DllPath1: string;
  CurrentDir, DllPath2, DllPath: string;
  Len: Integer;
  ErrMsg: string;
begin
  Notebook1.PageIndex := 1;
  InstTitleLabel.Caption := 'ACXg[󋵁';
  InstMemo.Lines.Clear;

  // CXg[pX𒲂ׂ
  if not GetInstalledDllPath(DllPath1) then begin
    InstMemo.Lines.Add('CXg[Ă܂B');
    Exit;
  end;

  InstMemo.Lines.Add('ACXg[Ă܂...');

  // JgfBNg𒲂ׂ
  SetLength(CurrentDir, 255);
  Len := GetCurrentDirectory(255, PChar(CurrentDir));
  SetLength(CurrentDir, Len);
  if CurrentDir[Length(CurrentDir)] = '\' then
    DllPath2 := CurrentDir + DLL_FILENAME
  else
    DllPath2 := CurrentDir + '\' + DLL_FILENAME;

  // CXg[ckkt@C݂Ă΁AgăWXgB
  // ݂Ȃ΃JgfBNgɂ ndaaloha.dll găWXgB
  if not FileExists(DllPath1) then begin
    if not FileExists(DllPath2) then begin
      InstMemo.Lines.Add( Format('%s  %s Ȃ߃ACXg[ł܂B', [DllPath1, DllPath2]) );
      InstMemo.Lines.Add( Format('ACXg[邽߂ɂ̓JgfBNg %s KvłB', [DLL_FILENAME]) );
      Exit;
    end
    else
      DllPath := DllPath2;
  end
  else
    DllPath := DllPath1;
  if not UninstallRegistry(DllPath, ErrMsg) then begin
    InstMemo.Lines.Add( ErrMsg );
    Exit;
  end;

  InstMemo.Lines.Add( Format('%s WXg܂B', [DllPath1]) );

  // ndaaloha.dll 폜
  if FileExists(DllPath1) then begin
    if DeleteFile(DllPath1) then
      InstMemo.Lines.Add( Format('%s 폜܂B', [DllPath1]) )
    else begin
      InstMemo.Lines.Add( Format('%s 폜ł܂B', [DllPath1]) );
      Exit;
    end;
  end
  else
    InstMemo.Lines.Add( Format('%s Ȃߍ폜܂B', [DllPath1]) );

  // ɃACXg[
  InstMemo.Lines.Add('ɃACXg[ł܂B');
end;

//**************************************************************************//
//  Name      | TMainForm.InstallButtonClick                                //
//  Comment   | uCXg[v{^̃NbN                        //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Sender          | I | InstallButton                                     //
//**************************************************************************//
procedure TMainForm.InstallButtonClick(Sender: TObject);
begin
  StartInstall;
end;

//**************************************************************************//
//  Name      | TMainForm.ExitButtonClick                                   //
//  Comment   | uCXg[̏Iv{^̃NbN                      //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Sender          | I | ExitButton                                        //
//**************************************************************************//
procedure TMainForm.ExitButtonClick(Sender: TObject);
begin
  Close;
end;

//**************************************************************************//
//  Name      | TMainForm.UninstallButtonClick                              //
//  Comment   | uACXg[v{^̃NbN                    //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Sender          | I | UninstallButton                                   //
//**************************************************************************//
procedure TMainForm.UninstallButtonClick(Sender: TObject);
begin
  StartUninstall;
end;

//**************************************************************************//
//  Name      | TMainForm.InstBackButtonClick                               //
//  Comment   | CXg[y[Ẃu߂v{^̃NbN                //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Sender          | I | InstBackButton                                    //
//**************************************************************************//
procedure TMainForm.InstBackButtonClick(Sender: TObject);
begin
  ShowMenuPage;
end;

//**************************************************************************//
//  Name      | TMainForm.InstCloseButtonClick                              //
//  Comment   | CXg[y[Ẃuv{^̃NbN              //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Sender          | I | InstCloseButton                                   //
//**************************************************************************//
procedure TMainForm.InstCloseButtonClick(Sender: TObject);
begin
  Close;
end;



//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
//                                                                          //
//   I                                                   //
//                                                                          //
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
initialization
  OleInitialize(nil);
finalization
  OleUninitialize;

end.
