//**************************************************************************//
//  Product     | AnobPʐMR|[lguAlohaPC1CommXv           //
//  Version     | 1.00 (Build 0)                                            //
//--------------------------------------------------------------------------//
//  Unit        | MOp                                            //
//--------------------------------------------------------------------------//
//  File Name   | Logger.pas                                                //
//  Platform    | Windows 2000                                              //
//  Compiler    | Delphi5,6                                                 //
//  Last Update | 2002/12/25                                                //
//--------------------------------------------------------------------------//
//  Copyright (c) 2002 Hitwareland Corporation.                             //
//  All rights reserved.                                                    //
//  programmed by Hitoshi Komatsu                                           //
//--------------------------------------------------------------------------//
//                      <<< Updated History >>>                             //
//--------------------------------------------------------------------------//
//  2002/10/ 9 | 쐬Jn                                                   //
//       10/12 | ftHgOt@C "c:\ndadapt.log"            //
//             | "c:\ndaaloha.log" ɕύXB                                 //
//       12/25 | Delphi5 ւ̑Ή                                           //
//**************************************************************************//
unit Logger;

interface

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
//                                                                          //
//   gpjbg錾                                                     //
//                                                                          //
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
uses
  { Delphi }
  SysUtils, Classes, Windows, SyncObjs;

type
  TLogType = (  // Of[^̎
    logTRACE,   // g[XbZ[W
    logDEBUG,   // fobOp
    logCOMMENT, // Cӂ̃Rg
    logWARNING, // nhOłG[
    logERROR);  // G[p

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
//                                                                          //
//   Oo̓NX                                                       //
//                                                                          //
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
  TFileLogger = class
  private
    FFileName: string;                  // Ot@CitpXj
    FFileStream: TFileStream;           // t@CXg[
    FCriticalSection: TCriticalSection; // XbhԔrpNeBJZNV
    FEnabled: Boolean;                  // Ot@Cɏoǂ
    procedure Lock;
    procedure Unlock;
    procedure SetEnabled(Value: Boolean);
    procedure SetFileName(const Value: string);
  public
    constructor Create(const FileName: string);
    destructor Destroy; override;
    procedure Add(const Msg: string; LogType: TLogType);
    property Enabled: Boolean read FEnabled write SetEnabled;
    property FileName: string read FFileName write SetFileName;
  end;

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
//                                                                          //
//   O[of[^                                                     //
//                                                                          //
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
var
  _Logger: TFileLogger;                 // Oo͗p

procedure ADDLOG(const Msg: string; LogType: TLogType);


implementation

const
  DEFAULT_LOGFILENAME = 'C:\ndaaloha.log';

  LOG_TYPE_STRS : array[TLogType] of string = (
    '[trace]',
    '[debug]',
    '[comnt]',
    '[warng]',
    '[error]');

//**************************************************************************//
//  Name      | ADDLOG                                                      //
//  Comment   | Ȍo                                              //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Msg             | I | Of[^                                        //
//  LogLevel        | I | Õ^Cv                                      //
//**************************************************************************//
procedure ADDLOG(const Msg: string; LogType: TLogType);
begin
  _Logger.Add(Msg, LogType);
end;



//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
//                                                                          //
//   Oo̓NXF\bh̎                                       //
//                                                                          //
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//

//**************************************************************************//
//  Name      | TFileLogger.Create                                          //
//  Comment   | RXgN^                                              //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  FileName        | I | Ot@CitpXj                      //
//**************************************************************************//
constructor TFileLogger.Create(const FileName: string);
begin
  FFileName   := FileName;
  FFileStream := nil;
  FEnabled    := False;

  // NeBJZNV̐
  FCriticalSection := TCriticalSection.Create;
end;

//**************************************************************************//
//  Name      | TFileLogger.Destroy                                         //
//  Comment   | fXgN^                                                //
//**************************************************************************//
destructor TFileLogger.Destroy;
begin
  // t@C
  FFileStream.Free;

  // NeBJZNV̔p
  FCriticalSection.Free;

  inherited; { TObject.Destroy }
end;

//**************************************************************************//
//  Name      | TFileLogger.Lock                                            //
//  Comment   | rJn                                                //
//**************************************************************************//
procedure TFileLogger.Lock;
begin
  FCriticalSection.Enter;
end;

//**************************************************************************//
//  Name      | TFileLogger.Unlock                                          //
//  Comment   | rI                                                //
//**************************************************************************//
procedure TFileLogger.Unlock;
begin
  FCriticalSection.Leave;
end;

//**************************************************************************//
//  Name      | TFileLogger.SetFileName                                     //
//  Comment   | o͐惍Ot@C̕ύX                                  //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  NewLogFileName  | I | VOt@C                              //
//**************************************************************************//
procedure TFileLogger.SetFileName(const Value: string);
begin
  Lock;
  try
    if not AnsiSameText(FFileName, Value) then begin
      // t@C
      FreeAndNil(FFileStream);
      FFileName := Value;
    end;
  finally
    Unlock;
  end;
end;

//**************************************************************************//
//  Name      | TFileLogger.SetEnabled                                      //
//  Comment   | Ot@Cɏoǂ̐ݒ                        //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Value           | I | True = o  False = oȂ             //
//**************************************************************************//
procedure TFileLogger.SetEnabled(Value: Boolean);
begin
  Lock;
  try
    if FEnabled <> Value then begin
      FEnabled := Value;
      // ɂꍇ݂͌̃t@C
      if not Value then
        FreeAndNil(FFileStream);
    end;
  finally
    Unlock;
  end;
end;

//**************************************************************************//
//  Name      | TFileLogger.Add                                             //
//  Comment   | Ȍo                                              //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Msg             | I | Of[^                                        //
//  LogLevel        | I | Õ^Cv                                      //
//**************************************************************************//
procedure TFileLogger.Add(const Msg: string; LogType: TLogType);
var
  DateStr, LogMsg: string;
begin
  Lock;
  try
    // OɏoȂꍇ͉Ȃ
    if not FEnabled then Exit;

    // ŏɏoƂɃt@CI[v
    if not Assigned(FFileStream) then begin
      try
        // fmCreate ̂Ƃ fmShareDenyWrite gȂ߈xt@C
        // 쐬ĂJȂ
        if not FileExists(FFileName) then begin
          FFileStream := TFileStream.Create(FFileName, fmCreate);
          FreeAndNil(FFileStream);
        end;
        FFileStream := TFileStream.Create(FFileName, fmOpenReadWrite or fmShareDenyWrite);
        FFileStream.Seek(0, soFromEnd); // f[^ꍇ͖Ɉړ
      except
      end;
    end;

    // t@CJꍇ̂ݏo
    if Assigned(FFileStream) then begin
      // "yyyy/mm/dd hh:mm:ss [LogLevel] Msg" `
      DateStr := FormatDateTime('yyyy"/"mm"/"dd hh":"mm":"ss', Now);
      LogMsg := Format('%s %s %s', [DateStr, LOG_TYPE_STRS[LogType], Msg]) + #13#10;
      try
        FFileStream.Write(PChar(LogMsg)^, Length(LogMsg));
        FlushFileBuffers(FFileStream.Handle);
      except end;
    end;
  finally
    Unlock;
  end;
end;



//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
//                                                                          //
//   AI                                                   //
//                                                                          //
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
initialization
  // K[̐
  _Logger := TFileLogger.Create(DEFAULT_LOGFILENAME);

finalization
  // K[̔p
  _Logger.Free;

end.
