//**************************************************************************//
//  Product     | AnobPʐMR|[lguAlohaPC1CommXv           //
//  Version     | 1.01 (Build 0)                                            //
//--------------------------------------------------------------------------//
//  Unit        | IPhoneNumner NX ("NDAlohaPC1.PhoneNumber")        //
//--------------------------------------------------------------------------//
//  File Name   | PhoneNumber.pas                                           //
//  Platform    | Windows 2000                                              //
//  Compiler    | Delphi5,6                                                 //
//  Last Update | 2002/12/25                                                //
//--------------------------------------------------------------------------//
//  Copyright (c) 2002 Hitwareland Corporation.                             //
//  All rights reserved.                                                    //
//  programmed by Hitoshi Komatsu                                           //
//--------------------------------------------------------------------------//
//                      <<< Updated History >>>                             //
//--------------------------------------------------------------------------//
//  2002/10/ 9 | 쐬Jn                                                   //
//       10/28 | RȌꍇɂ܂ȂAhX     //
//             | dbԍ̎ނ ntNoNumber ɂ悤ɂB             //
//       12/25 | Delphi5 ւ̑Ή                                           //
//**************************************************************************//
unit PhoneNumber;

{$ifndef VER130} // not D5
{$WARN SYMBOL_PLATFORM OFF}
{$endif}

interface

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
//                                                                          //
//   gpjbg錾                                                     //
//                                                                          //
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
uses
  { Delphi }
  ComObj, ActiveX, StdVcl, SysUtils,

  { Hitwareland VCL }
  AlohaPC1Comm,

  { This Project}
  NDAAlohaPC1_TLB, Logger;

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
//                                                                          //
//   "NDAlohaPC1.PhoneNumber" dbԍf[^NX                        //
//                                                                          //
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
type
  TPhoneNumber = class(TAutoObject, IPhoneNumber)
  private
    FMonth: Smallint;                   // 
    FDay: Smallint;                     // 
    FDayOfWeek: Smallint;               // j
    FHour: Smallint;                    // 
    FMinute: Smallint;                  // 
    FNumType: Smallint;                 // dbԍ̎
    FNumber: string;                    // dbԍ
    procedure ADDLOG(const Msg: string; LogType: TLogType);
  protected
    function Get_Day: Smallint; safecall;
    function Get_DayOfWeek: Smallint; safecall;
    function Get_Hour: Smallint; safecall;
    function Get_Minute: Integer; safecall;
    function Get_Month: Smallint; safecall;
    function Get_Number: WideString; safecall;
    function Get_NumType: NumberType; safecall;
    { Protected 錾 }
  public
    constructor Create(const Packet: TPhoneNumberPacket);
    destructor Destroy; override;
    procedure Initialize; override;
  end;

implementation

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
//                                                                          //
//   gpjbg錾                                                     //
//                                                                          //
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
uses ComServ;

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
//                                                                          //
//   "NDAlohaPC1.PhoneNumber" dbԍf[^NXF\bh̎        //
//                                                                          //
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//

//**************************************************************************//
//  Name      | TPhoneNumber.ADDLOG                                         //
//  Comment   | Ȍo                                              //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Msg             | I | Of[^                                        //
//  LogLevel        | I | Õ^Cv                                      //
//**************************************************************************//
procedure TPhoneNumber.ADDLOG(const Msg: string; LogType: TLogType);
var
  ObjMsg: string;
begin
  ObjMsg := Format('[$%s] %s', [IntToHex(Integer(Self), 8), Msg]);
  Logger.ADDLOG(ObjMsg, LogType);
end;

//**************************************************************************//
//  Name      | TPhoneNumber.Create                                         //
//  Comment   | RXgN^                                              //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Packet          | I | dbԍf[^                                    //
//**************************************************************************//
constructor TPhoneNumber.Create(const Packet: TPhoneNumberPacket);
var
  Buf: array[0..20] of Char;
begin
  inherited Create; { TComObject.Create }

  FillChar(Buf, SizeOf(Buf), 0);

  // 
  Move(Packet.Month, Buf, 2);
  FMonth := StrToIntDef(Buf, -1);

  // 
  Move(Packet.Day, Buf, 2);
  FDay := StrToIntDef(Buf, -1);

  // j
  FDayOfWeek := Byte(Packet.DayOfWeek) - Byte('0');

  // 
  Move(Packet.Hour, Buf, 2);
  FHour := StrToIntDef(Buf, -1);

  // 
  Move(Packet.Minute, Buf, 2);
  FMinute := StrToInt(Buf);

  // dbԍ̎
  case Packet.NumberType of
    'P':      FNumType := ntUnnotify;      // NUMTP_UNNOTIFY (ʒm)
    'O', 'S': FNumType := ntOutOfRange;    // NUMTP_OUTOFRANGE (\O)
    'C':      FNumType := ntPublicPhone;   // NUMTP_PUBLICPHONE (Odb)
    '0'..'9': FNumType := ntValidNumber;   // NUMTP_VALIDNUMBER (Lȓdbԍ)
    ' ':      FNumType := ntNoNumber;      // NUMTP_NONUMBERidbԍȂji2002/10/28ǉj
    else      FNumType := ntError;         // NUMTP_ERROR (G[)
  end;

  // dbԍ
  Move(Packet.Number, Buf, 20);
  Buf[20] := #0;
  FNumber := TrimRight(string(Buf));
end;

//**************************************************************************//
//  Name      | TPhoneNumber.Initialize                                     //
//  Comment   | [`iRXgN^ɑΉj                      //
//--------------------------------------------------------------------------//
//  Note      | OvO{NX̃IuWFNg쐬ۂɂ    //
//            | TPhoneNumber.Create RXgN^͌Ă΂Ȃ -            //
//            | iĂяoȂj߁Ã\bhɖ{RXgN -  //
//            | sLqB                                        //
//**************************************************************************//
procedure TPhoneNumber.Initialize;
begin
  ADDLOG('IPhoneNumber IuWFNg', logTRACE);

  inherited Initialize; { TAutoObject.Initialize }
end;

//**************************************************************************//
//  Name      | TPhoneNumber.Destroy                                        //
//  Comment   | fXgN^                                                //
//**************************************************************************//
destructor TPhoneNumber.Destroy;
begin
  ADDLOG('IPhoneNumber IuWFNgp', logTRACE);

  inherited; { TComObject.Destroy }
end;

//**************************************************************************//
//  Name      | TPhoneNumber.Get_Month                                      //
//  Comment   | ̎擾                                                    //
//--------------------------------------------------------------------------//
//  Result    | i1 ` 12j                                               //
//**************************************************************************//
function TPhoneNumber.Get_Month: Smallint;
begin
  Result := FMonth;
end;

//**************************************************************************//
//  Name      | TPhoneNumber.Get_Day                                        //
//  Comment   | ̎擾                                                    //
//--------------------------------------------------------------------------//
//  Result    | i1 ` 31j                                               //
//**************************************************************************//
function TPhoneNumber.Get_Day: Smallint;
begin
  Result := FDay;
end;

//**************************************************************************//
//  Name      | TPhoneNumber.Get_DayOfWeek                                  //
//  Comment   | j̎擾                                                  //
//--------------------------------------------------------------------------//
//  Result    | ji0: ` 6:yj                                        //
//**************************************************************************//
function TPhoneNumber.Get_DayOfWeek: Smallint;
begin
  Result := FDayOfWeek;
end;

//**************************************************************************//
//  Name      | TPhoneNumber.Get_Hour                                       //
//  Comment   | ̎擾                                                    //
//--------------------------------------------------------------------------//
//  Result    | i0 ` 23j                                               //
//**************************************************************************//
function TPhoneNumber.Get_Hour: Smallint;
begin
  Result := FHour;
end;

//**************************************************************************//
//  Name      | TPhoneNumber.Get_Minute                                     //
//  Comment   | ̎擾                                                    //
//--------------------------------------------------------------------------//
//  Result    | i0 ` 59j                                               //
//**************************************************************************//
function TPhoneNumber.Get_Minute: Integer;
begin
  Result := FMinute;
end;

//**************************************************************************//
//  Name      | TPhoneNumber.Get_NumType                                    //
//  Comment   | dbԍ̎ނ̎擾                                        //
//--------------------------------------------------------------------------//
//  Result    | 0 = ntValidNumber = Lȓdbԍ                          //
//            | 1 = ntUnnotify    = ʒm                                  //
//            | 2 = ntOutOfRange  = \O                                //
//            | 3 = ntPublicPhone = Odb                                //
//            | 4 = ntError       = G[                                  //
//**************************************************************************//
function TPhoneNumber.Get_NumType: NumberType;
begin
  Result := NumberType(FNumType);
end;

//**************************************************************************//
//  Name      | TPhoneNumber.Get_Number                                     //
//  Comment   | dbԍ̎                                              //
//--------------------------------------------------------------------------//
//  Result    | dbԍiNumType=0 ̂Ƃ̂ݗLj                        //
//**************************************************************************//
function TPhoneNumber.Get_Number: WideString;
begin
  Result := WideString(FNumber);
end;



//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
//                                                                          //
//                                                              //
//                                                                          //
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
initialization
  TAutoObjectFactory.Create(ComServer, TPhoneNumber, Class_PhoneNumber,
    ciMultiInstance, tmApartment);
end.
